/* -*- mode: C++; tab-width: 4 -*- */
/* ===================================================================== *\
	Copyright (c) 1999-2001 Palm, Inc. or its subsidiaries.
	All rights reserved.

	This file is part of the Palm OS Emulator.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
\* ===================================================================== */

#ifndef EmCommonMac_h
#define EmCommonMac_h

// Common header file included by all Palm OS Emulator for Mac files.

// Bring in some base host types.  In particular, we need to make
// sure PRAGMA_STRUCT_ALIGN is defined for PalmPack[Pop].h, which
// is brought in by Palm.h

#include <MacTypes.h>


// Palm headers

#include "Palm.h"


// Std C/C++ Library stuff

#include <ctype.h>				// isalpha, tolower
#include <stdarg.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <algorithm>			// find, sort
#include <deque>				// deque
#include <list>					// list
#include <string>
#include <utility>				// pair
#include <vector>
#include <map>

#include <alloca.h>
#define _alloca alloca


// PowerPlant headers

#pragma once on

#if	__option(precompile)
	#if defined (NDEBUG)
		#include <PP_ClassHeaders.cp>
	#endif

	#if defined (_DEBUG)
		#include <PP_DebugHeaders.cp>
	#endif
#else
	#if defined (NDEBUG)
		#include <PP_ClassHeaders.h>
	#endif

	#if defined (_DEBUG)
		#include <PP_DebugHeaders.h>
	#endif
#endif


// Check the versions of the tools we're being built with.

#if ((__PowerPlant__ & 0xFFFF0000) < 0x02000000)

	#error "Palm OS Emulator needs to be built with PowerPlant 2.0.0"

#endif

#if (__MWERKS__ < 0x2301)

	#error "Palm OS Emulator needs to be built with C/C++ Compiler 2.3.1 or later"
	#error "C/C++ Compiler 2.3.1 is part of CodeWarrior Pro 5.2"

#endif

// ============================================
// ========== Windows socket mapping ==========
// ============================================

#include <sys/types.h>
#include <sys/socket.h>			// socklen_t

#if PLATFORM_UNIX && !defined(HAVE_TYPE_SOCKLEN_T)
	typedef int			socklen_t;	// not defined in <sys/socket.h> on solaris or FreeBSD
#endif

typedef int				SOCKET;

#define WSAEINVAL		EINVAL
#define INVALID_SOCKET	((SOCKET) (~0))
#define SOCKET_ERROR	(-1)
#define closesocket		close
#define ioctlsocket		ioctl

#ifndef INADDR_LOOPBACK
#define INADDR_LOOPBACK	0x7f000001
#endif

#endif	/* EmCommonMac_h */
