/* -*- mode: C++; tab-width: 4 -*- */
/* ===================================================================== *\
	Copyright (c) 2000-2001 Palm, Inc. or its subsidiaries.
	All rights reserved.

	This file is part of the Palm OS Emulator.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
\* ===================================================================== */

#ifndef EmDirRefMac_h
#define EmDirRefMac_h

#include "EmDirRef.h"

Bool	PrvEqualAlias		(AliasHandle, AliasHandle);
Bool	PrvEqualFSSpec		(const FSSpec&, const FSSpec&);
Bool	PrvIsType			(const FSSpec& inSpec, OSType, const char* suffix);

Bool	PrvIsSpecified		(const FSSpec&);
void	PrvUnspecify		(FSSpec*);

FSSpec	PrvGetParentSpec	(const FSSpec& inSpec);
string	PrvGetFullPath		(const FSSpec& inSpec);
void	PrvGetAppVolDir		(short* vol, long* dir);
void	PrvGetDirVolDir		(const EmDirRef&, short* vol, long* dir);

Bool	PrvSpecExists		(const FSSpec&);

void	PrvMakeSpec			(const LStr255& name, FSSpec* result);
void	PrvMakeSpec			(const EmDirRef& parent, const LStr255& name, FSSpec* result);
void	PrvMakeSpec			(short vRefNum, long dirID, const LStr255& name, FSSpec* result);

#endif	/* EmDirRefMac_h */
