/* -*- mode: C++; tab-width: 4 -*- */
/* ===================================================================== *\
	Copyright (c) 2000-2001 Palm, Inc. or its subsidiaries.
	All rights reserved.

	This file is part of the Palm OS Emulator.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
\* ===================================================================== */

#ifndef EmSPISlaveSTMicro_h
#define EmSPISlaveSTMicro_h

#include "EmSPISlave.h"			// EmSPISlave

#define MaxScanCodeArray		20
const int		kAlphaSmartNumButtonCols = 16;


class EmSPISlaveSTMicro : public EmSPISlave
{
	public:
								EmSPISlaveSTMicro		(void);
		virtual					~EmSPISlaveSTMicro		(void);

		virtual uint16			DoExchange				(uint16 control, uint16 data);

		void					LoadData (uint8 *rowDataArray, uint8 *rowDataSendKeepArray,
									uint16 bufferLength);
		bool					IRQ1Assert (void);
		void					SetResetMode (void);
	protected:

		void					BuildScancodeArray (void);
		void					HandleKeyToScanCode (void);
		void					HandleButtonToScanCode (void);
		uint16					CheckForVersion (uint16 data);

	private:
			// our scan code list that we use to send to the host
		uint16					fScanCodeListCount;
		uint16					fScanCodeNextIndex;
		uint8					fScanCodeArray[MaxScanCodeArray];
		bool					fInterruptState;
		

		uint8					rowData[kAlphaSmartNumButtonCols];
		uint8					rowDataSendKeep[kAlphaSmartNumButtonCols];
		bool					shiftButtonDown;

		uint8					fCmdStringIndex;
		uint8					fVersionStringIndex;
		bool					fSendVersion;
		bool					fDoingReset;
		uint16					fkeyState;


};

#endif	// EmSPISlaveSTMicro_h

